/**********************************************************************
vpc_data.c      actual storage of all data here
**********************************************************************/

#include "vpc_play.h"

// global variables
int race;//AS INTEGER
CONFIGTYPE fig;// AS CONFIGTYPE
char path[255];//AS STRING
char regname[25];// AS STRING * 25
char regad[25];// AS STRING * 25
int lowtech ;//AS INTEGER
int classlist[105];//(105) ;//AS INTEGER
//Added by Miikka
int informative=0;  //informative mode.  higher means more
int no_cheating=0;  //computer cheats flag. higher means less
int is_hidden=1;    //means my race has not been seen by other players yet
		    //because i have hid my ships by cloaking etc...
int emergency=0;    //how bad an emergency i am in 100==about to die 0==safe
int dominion[500];  //update every race which stars are in my dominion
int greatest_x=1000;
int least_x=3000;
int greatest_y=1000;
int least_y=3000;

int factories[500];  //refresh all these every race
long colonists[500];
long natives[500];
long money[500];
int mines[500];
int defenses[500];

int cheat_with_colonies=0;
int cheat_with_borg=0;
int cheat_with_empire=0;
int cheat_with_robots=0;
int cheat_with_privateers=0;
int cheat_with_rebels=0;
int cheat_with_feds=0;
int cheat_with_lizards=0;
int cheat_with_romulans=0;
int cheat_with_klingons=0;
int cheat_with_crystal=0;

int no_politics_disasters=0;
//this is a total band-aid fix variable, array that tells you which
//minefield you are inside!!!!
int in_a_minefield[500]; //one slot per ship (refresh every race)
int planet_in_a_minefield[500]; //one slot per planet (refresh every race)

int pcount=0;
int sbcount=0;
int epcount=0;
int dominion_unexplored_count=0;
int total_dominion=0;

int scouts=0;
int eggs=0;
int destroyers=0;
int battleships=0;
int refineries=0;
int merlins=0;
int fuel_carriers=0;
int big_eggs=0;
int specials=0;

float fuzzy_scouts=0.0;
float fuzzy_eggs=0.0;
float fuzzy_warships=0.0;

int ships_counted=0;



//debugging and command line options
int convex_trial=0;
int strategy_option=0;
int intercept_called=0;

//for economic tracking
long total_eleN_consumption=0;
long total_eleS_consumption=0;
long total_eleT_consumption=0;
long total_eleD_consumption=0;
long total_eleM_consumption=0;
long total_cash_consumption=0;
long total_eleC_consumption=0;

long total_eleN_production=0;
long total_eleS_production=0;
long total_eleT_production=0;
long total_eleD_production=0;
long total_eleM_production=0;
long total_cash_production=0;
long total_eleC_production=0;


const char speciesname[10][20] = {
"None               \0",   //type 0 means none
"Humanoid           \0",
"Bovinoid           \0",
"Reptian            \0",
"Avian              \0",
"Amorphous          \0",   //type 5
"Insectoid          \0",
"Amphibious         \0",
"Ghipsoldal         \0",
"Silicoid           \0"
};

const char shipname[75][18] = {
	  "Death Star       \0",
	  "Botany Bay       \0",
	  "Red October      \0",
	  "Eat Flaming Death\0",
	  "Rust Bucket      \0",
	  "Tax Man          \0",
	  "Space Seed       \0",
	  "USS Enterprise   \0",
	  "Termy            \0",
	  "Death From Above \0",
	  "The Searcher     \0",
	  "USS Sean Penn    \0",
	  "USS Gates        \0",
	  "Raptor           \0",
	  "Heart of Topring \0",
	  "Topaw            \0",
	  "USS Stargazer    \0",
	  "USS Lint-Head    \0",
	  "USS Kennedy      \0",
	  "USS Reagan       \0",
	  "USS Kaden        \0",
	  "USS Kaiser       \0",
	  "USS Kammere      \0",
	  "USS Kang         \0",
	  "USS Kashi        \0",
	  "USS Keller       \0",
	  "USS Kelly        \0",
	  "Portland         \0",
	  "USS Hood         \0",
	  "Casnovia         \0",
	  "USS Tucson       \0",
	  "USS Daytona      \0",
	  "USS Hamilton     \0",
	  "USS Providence   \0",
	  "Atlanta          \0",
	  "Tacoma           \0",
	  "Phoenix Sun      \0",
	  "USS Spokane      \0",
	  "Yorktown         \0",
	  "Seabrook         \0",
	  "USS Redmond      \0",
	  "USS Bellevue     \0",
	  "The Knoxville    \0",
	  "HMCS Kamloops    \0",
	  "USS Orem         \0",
	  "USS Aptos        \0",
	  "USS Bush         \0",
	  "Durham           \0",
	  "Sierra           \0",
	  "USS Reston       \0",
	  "California       \0",
	  "USS Forestfire   \0",
	  "USS Independence \0",
	  "Monkey Business  \0",
	  "USS Minnow       \0",
	  "Larry Bud Melman \0",
	  "Assimilator      \0",
	  "USS Wallace      \0",
	  "USS Billery      \0",
	  "USS Joyceland    \0",
	  "Lizard Face      \0",
	  "USS Al Gore      \0",
	  "USS Ackman       \0",
	  "USS Emmit Smith  \0",
	  "USS Rush         \0",
	  "Demolisher       \0",
	  "USS Immortal     \0",
	  "Milennium Falcon \0",
	  "Lizzy III Sucks  \0",
	  "Lizzy III Rules  \0",
	  "USS Snakey       \0",
	  "USS Poldo        \0",
	  "USS Mustafa      \0",
	  "USS Arianaichka  \0",
	  "USS Splotch      \0"
};


#ifdef __HUGE__
//fuzzyvector describes a ships scout/freighter/warshipness
//same as shipclass but for fuzzy logic bit
const float shipfuzzyclass[11][20][3] = {        //race,hull,fuzzyclassvector
{{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5}},       //feds
{{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,2.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //lizard
{{0.1,1.0,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,2.0},{1.0,0.1,0.1},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //romulan
{{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{0.1,0.1,1.0},{1.0,0.1,0.1},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //kli
{{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5}},       //pri
{{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,2.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //borg
{{1.0,0.1,0.1},{0.1,0.1,0.1},{0.1,1.0,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,2.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //tholians
{{1.0,0.1,0.1},{0.1,0.1,1.0},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,0.1,0.1},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,1.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //empire ru25==sentinel carrier=fighter pod
{{1.0,0.1,0.1},{0.1,0.1,0.1},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,1.0,0.1},{0.1,0.1,1.0},{0.1,0.1,2.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}},       //cylons   //inst==small war
{{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5}},       //reb
{{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.6,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,1.0,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{1.0,0.1,0.1},{0.1,0.1,1.0},{0.1,0.1,0.4},{0.1,2.0,0.1},{0.1,0.1,2.0},{0.1,0.1,0.5}}        //colonies
};

float fuzzyclasslist[105][3];//remapped version of above
#endif

const int shipclass[11][20] = {  //race first then hull design
{1,1,1,2,1,1,3,2,2,1,1,3,1,1,1,1,5,8,4,6},       // race 1   feds
{1,1,7,1,1,9,1,3,2,3,3,4,5,8,4,6,0,0,0,0},       //lizard
{2,1,7,2,1,1,1,3,3,2,3,3,4,1,5,8,4,6,0,0},       //romulan
{2,1,1,7,2,1,2,3,1,2,3,3,3,3,5,8,4,6,0,0},       // race 4 kli
{1,1,1,1,1,7,1,1,1,1,1,3,1,1,2,1,5,8,4,6},       // pri
{1,1,1,1,1,1,1,1,2,3,4,5,8,4,6,0,0,0,0,0},       //borg
{1,9,2,7,1,1,1,3,2,3,3,4,5,8,4,6,0,0,0,0},       //tholians
{1,3,1,1,1,7,1,1,3,9,2,3,3,5,8,4,6,0,0,0},       //empire ru25==sentinel carrier=fighter pod
{1,9,3,2,7,1,3,2,3,4,5,8,4,6,0,0,0,0,0,0},       //cylons   //inst==small war
{1,1,1,1,7,1,1,1,1,1,1,2,1,1,1,3,5,8,4,6},       //reb
{1,1,1,1,7,1,1,1,1,1,2,1,1,1,1,3,5,8,4,6}        // race 11  colonies
};       //6 //8 //0 //2 //4 //6 //8

int cloaklist[105];//remapped version of below using truehull (low IQ but works)

const int shipcloak[11][20] = {  // ships have cloaking device
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0},//liz
{0,1,0,0,1,1,0,1,0,0,0,1,1,1,0,0,1,0,0,0},//rom
{0,0,0,0,0,1,0,0,1,0,0,1,0,0,0,0,0,0,0,0},//kli
{0,0,0,0,0,0,0,1,1,0,0,1,0,1,0,1,0,0,0,0},//pri
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},//tholians
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
};



int pbrain[500];//(500) ;//AS INTEGER
int abrain[500];//(500) ;//AS INTEGER
int ebrain[11];//(11) ;//AS INTEGER
int playrace[11];//(11) ;//AS INTEGER
int truehull[11][20];//(20, 11) ;//AS INTEGER
int mapx[500];//(500) ;//AS INTEGER
int mapy[500];//(500) ;//AS INTEGER
int mapr[500];//(500) ;//AS INTEGER
int mapm[500];//(500) ;//AS INTEGER
int mapc[500];//(500) ;//AS INTEGER
int xPlanet[500];//(500) ;//AS INTEGER
int yPlanet[500];//(500) ;//AS INTEGER
int rPlanet[500];//(500) ;//AS INTEGER
int rBase[500];//(500) ;//AS INTEGER
int ingame[11];//(11) ;//AS INTEGER
int plrace[11];//(11) ;//AS INTEGER
int cprace[11];//(11) ;//AS INTEGER
int frrace[11];//(11) ;//AS INTEGER
int bsrace[11];//(11) ;//AS INTEGER
int dumpoldm[11];//(11) ;//AS INTEGER
int xmine[500];//(500) ;//AS INTEGER
int ymine[500];//(500) ;//AS INTEGER
long zmine[500];//(500) ;//AS LONG
int rmine[500];//(500) ;//AS INTEGER
int wmine[500];//(500) ;//AS INTEGER